
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ir_announcementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ir_announcements = await db.ir_announcements.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        announced_at: data.announced_at
        ||
        null
            ,
            
        body: data.body
        ||
        null
            ,
            
        source_url: data.source_url
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ir_announcements.setIr_company( data.ir_company || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ir_announcements.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: ir_announcements.id,
            },
            data.attachments,
            options,
        );
        

        return ir_announcements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ir_announcementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                announced_at: item.announced_at
            ||
            null
            ,
            
                body: item.body
            ||
            null
            ,
            
                source_url: item.source_url
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ir_announcements = await db.ir_announcements.bulkCreate(ir_announcementsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < ir_announcements.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.ir_announcements.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: ir_announcements[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return ir_announcements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const ir_announcements = await db.ir_announcements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.announced_at !== undefined) updatePayload.announced_at = data.announced_at;
        
        
        if (data.body !== undefined) updatePayload.body = data.body;
        
        
        if (data.source_url !== undefined) updatePayload.source_url = data.source_url;
        
        
        updatePayload.updatedById = currentUser.id;

        await ir_announcements.update(updatePayload, {transaction});

        
        
        if (data.ir_company !== undefined) {
            await ir_announcements.setIr_company(
              
              data.ir_company,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ir_announcements.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: ir_announcements.id,
            },
            data.attachments,
            options,
        );
        

        return ir_announcements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ir_announcements = await db.ir_announcements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ir_announcements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ir_announcements) {
                await record.destroy({transaction});
            }
        });


        return ir_announcements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ir_announcements = await db.ir_announcements.findByPk(id, options);

        await ir_announcements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ir_announcements.destroy({
            transaction
        });

        return ir_announcements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ir_announcements = await db.ir_announcements.findOne(
            { where },
            { transaction },
        );

        if (!ir_announcements) {
            return ir_announcements;
        }

        const output = ir_announcements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.ir_company = await ir_announcements.getIr_company({
            transaction
        });
        
        
        output.attachments = await ir_announcements.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.ir_companies,
        as: 'ir_company',
        
        where: filter.ir_company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.ir_company.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.ir_company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_announcements',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_announcements',
                        'body',
                        filter.body,
                    ),
                };
            }
            
            if (filter.source_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_announcements',
                        'source_url',
                        filter.source_url,
                    ),
                };
            }
            

            
            

            
            if (filter.announced_atRange) {
                const [start, end] = filter.announced_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    announced_at: {
                    ...where.announced_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    announced_at: {
                    ...where.announced_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ir_announcements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ir_announcements',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ir_announcements.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

